package com.example.mapstruct.service;

import com.example.mapstruct.Mapper.EmployeeMapper;
import com.example.mapstruct.dto.EmployeeGetDto;
import com.example.mapstruct.dto.EmployeePostDto;
import com.example.mapstruct.model.Employee;
import com.example.mapstruct.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Optional;

@Service
public class EmployeeService {

    @Autowired
    private EmployeeRepository repository;

    @Autowired
    private EmployeeMapper mapper;

    public EmployeeGetDto findEmployeeById(int id) {
        Optional<Employee> employee = repository.findById(id);
        EmployeeGetDto employeeGetDto = mapper.modelToDto(employee.get());
        return employeeGetDto;
    }

    public Employee createEmployee(EmployeePostDto employeePostDto) {
        Employee employee = mapper.dtoToModel(employeePostDto);
        employee.setActive(true);
        return repository.save(employee);
    }
}
